; CANview by Professor Nimnul // BYTEFALL Gr0uP
; All Rights Reserved, CopyLefted (c) by Professor Nimnul
;--------------------------------------------------------------
include lite_mac.inc
;--------------------------------------------------------------
.model tiny
.code
.286
locals
org 100h

Start:
;---------------------
;Prepare Screen. Special for crazy ArcView, which set cursor under last row :(
        PUSH    CS
        POP     DS
        PUSH    CS
        POP     ES

	call	GetCursor	
	CALL    GetMaxRow               ;25/30/40/50 rows now?
	cmp	al,dh
	jnb	OkScr

;CLS
	mov	dh,al
	MOV     DL,79
	XOR     CX,CX                   
	MOV     AX,600H
	MOV     BH,7			
	INT     10H
;Set at Home
	XOR     DX,DX                   
	mov	bh,0
	mov	ah,2
	int	10h
OkScr:
;---------------------
	Msg	_Title
	mov	si,81h
	ParseComLine	FName
	jnc	Work
	Msg	_Usage
	jmp	Exit

Work:
	Open	FName
	mov	FHandle,ax

        Read    2,BUFFER
	jc	Error

        cmp     word ptr BUFFER, 01CAh
        jz      RepeatRead0

        Msg     _NotSupport
        jmp     Error

RepeatRead0:
	mov	dx,offset BUFFER
Readed	= 07FFFh
	mov	cx,Readed

RepeatRead:
	mov	bx,FHandle
	mov	ah,3Fh
	int	21h
	jc	Error

	cmp	dx,offset BUFFER
	jnz	CalcLen

	or	ax,ax
	jz	PressAnyKey

CalcLen:
	sub	cx,ax
	mov	ax,Readed
	sub     ax,cx
	mov	word ptr _CX,ax     
	mov	si,offset BUFFER
	call	CANSHOW
	
	mov	cx,word ptr _CX
	cmp     cx,0 
	jbe	RepeatRead0
	mov	di,offset BUFFER
	mov	ax,cx
	cld
	rep	movsb
	mov	dx,di
	mov	cx,Readed
	sub	cx,ax

	jmp	RepeatRead

PressAnyKey:
	xor 	ax,ax
	int	16h

Error:
	Close

Exit:
	.EXIT

;--------------------------------------------------------------
include canshow.inc
include lite_pro.inc
;--------------------------------------------------------------
_Title	db	"CAN-files viewer, v0.01 ALFA, CopyLefted (c) by Professor Nimnul '96",NL,'$'
_Usage	db	"Usage: CANview <CrunchedANsi file>",NL,'$'
_NotSupport     db      "Not Supported format of file.",NL,'$'
;--------------------------------------------------------------
ATTR	db	7
CursPoz	dw	?
_CX 	dw	?
FHandle dw	?           
FName	db	80 dup (?)

BUFFER:
;--------------------------------------------------------------
	end Start